<template>
  <div class="dish-wrapper row" @click="$emit('click')">
    <!-- <div class="count-selector">
      <div class="count-selector-value">{{ data.count }}</div>
      <select
        @click.stop
        class="count-selector-input"
        ref="countSelector"
        v-model="data.count"
      >
        <option v-for="(n, key) in data.count" :key="key" :value="n">{{
          n
        }}</option>
      </select>
    </div> -->
    <div class="info col">
      <div class="row">
        <div class="count col border text-center">{{ data.count }}</div>
        <div class="name col">{{ data.dish.name }}</div>
        <div class="price col"><price :price="data.price" /></div>
      </div>
      <div class="row">
        <div class="col"></div>
        <!-- <div class="en-name col">Combo 3 people sets</div> -->
        <div class="remove-wrapper col">
          <button class="remove" @click.stop="$emit('remove')">
            {{ $t("preorderCartPanel.remove") }}
          </button>
        </div>
      </div>
      <div class="desc">
        <div v-if="extras">{{ extras }}</div>
        <div v-if="data.note">
          {{ $t("preorderCartPanel.productNote", { note: data.note }) }}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Price from "@/components/Price";

export default {
  props: {
    data: {
      type: Object
    }
  },

  components: {
    Price
  },

  computed: {
    extras() {
      const extraMap = this.data.dish.extras.reduce((map, extra) => {
        map[extra.id] = extra.items.reduce((map, item) => {
          map[item.id] = item;
          return map;
        }, {});
        return map;
      }, {});
      return Object.keys(this.data.extra)
        .map(extraId => {
          return this.data.extra[extraId].map(itemId => {
            return extraMap[extraId][itemId].name;
          });
        })
        .reduce((all, names) => all.concat(names), [])
        .join("、");
    }
  },

  watch: {
    "data.count": function() {
      this.data.price = this.data.count * this.data.dish.price;
      this.$emit("updateCount", this.data);
    }
  },

  methods: {
    updateCount() {
      const value = Number(this.$refs.countSelector.value) || 0;
      if (!value) {
        this.remove();
        return;
      }
      // this.$emit('updateCount', value);
    },

    remove() {
      this.$emit("remove");
    }
  }
};
</script>

<style lang="scss" scoped>
.count-selector {
  margin-top: 8px;
  position: relative;
  display: inline-block;
  padding: 0 30px 0 12px;
  border: solid 1px $color-pigeon-grey;
  border-radius: 2px;
  background-image: linear-gradient(
    to bottom,
    $color-white,
    $color-genesis-white
  );
  cursor: pointer;
  box-sizing: border-box;
  height: 24px;
  margin-right: 15px;

  &::after {
    position: absolute;
    right: 10px;
    top: 50%;
    margin-top: -2px;
    content: "";
    width: 0;
    height: 0;
    border-left: 6px solid transparent;
    border-right: 6px solid transparent;
    border-top: 6px solid $color-primary-grey;
    pointer-events: none;
  }
}

.count-selector-value {
  line-height: 22px;
  text-align: center;
  font-size: 13px;
  font-weight: 500;
  color: $color-skm-red;
  vertical-align: middle;
}

.count-selector-input {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  opacity: 0;
}

.row {
  display: flex;
}

.col {
  flex: 1;
}

.price,
.en-name,
.remove {
  white-space: nowrap;
}

.name,
.price {
  font-size: 14px;
}

.count {
  flex: 1 1 10%;
  color: $color-skm-red;
}

.name {
  flex: 1 1 70%;
}

.price {
  flex: 1 1 20%;
}

.en-name,
.desc {
  font-size: 12px;
  color: $color-primary-grey;
}

.price,
.remove {
  text-align: right;
}

.remove {
  font-size: 13px;
  color: $color-skm-red;
  background: none;
  border: none;
  margin: 0;
  padding: 0;
  cursor: pointer;
}

.remove-wrapper {
  text-align: right;
}

.info .row {
  align-items: center;
  margin-bottom: 2px;
}

.desc {
  padding-right: 54px;
  line-height: 1.67em;
}
</style>
